#
# spec file for package mgr-virtualization
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
# Copyright (c) 2008-2018 Red Hat, Inc.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


# package renaming fun :(
%define rhn_client_tools spacewalk-client-tools
%define rhn_setup	 spacewalk-client-setup
%define rhn_check	 spacewalk-check
%define rhnsd		 mgr-daemon
# Old name and version+1 before renaming to mgr-push
%define oldname          rhn-virtualization
%define oldversion       5.4.73
#
%define rhn_dir %{_datadir}/rhn
%define rhn_conf_dir %{_sysconfdir}/sysconfig/rhn
%define cron_dir %{_sysconfdir}/cron.d

%if 0%{?fedora} || 0%{?suse_version} > 1320 || 0%{?rhel} >= 8
%global build_py3   1
%global default_py3 1
%endif

%if ( 0%{?fedora} && 0%{?fedora} < 28 ) || ( 0%{?rhel} && 0%{?rhel} < 8 ) || 0%{?suse_version}
%global build_py2   1
%endif

%define pythonX %{?default_py3: python3}%{!?default_py3: python2}

Name:           mgr-virtualization
Summary:        Spacewalk action support for virualization
License:        GPL-2.0-only
Group:          System Environment/Base
Version:        4.2.1
Provides:       rhn-virtualization = %{oldversion}
Obsoletes:      rhn-virtualization < %{oldversion}
Release:    1.17.1

Url:            https://github.com/uyuni-project/uyuni
Source0: mgr-virtualization-git-0.0daba5b.tar.gz
Source1:        %{name}-rpmlintrc

BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?fedora} || 0%{?rhel} || 0%{?suse_version} >= 1210
BuildArch:      noarch
%endif
%if 0%{?suse_version}
# make chkconfig work in OBS
BuildRequires:  sysconfig
BuildRequires:  syslog
%endif

%description
rhn-virtualization provides various Spacewalk actions for manipulation
virtual machine guest images.

%if 0%{?build_py2}
%package -n python2-%{name}-common
Summary:        Files needed by rhn-virtualization-host
Group:          System Environment/Base
%{?python_provide:%python_provide python2-%{name}-common}
Provides:       python-%{name}-common = %{oldversion}
Obsoletes:      python-%{name}-common < %{oldversion}
Provides:       python2-%{oldname}-common = %{oldversion}
Obsoletes:      python2-%{oldname}-common < %{oldversion}
Provides:       %{name}-common = %{oldversion}
Obsoletes:      %{name}-common < %{oldversion}
Provides:       %{oldname}-common = %{oldversion}
Obsoletes:      %{oldname}-common < %{oldversion}
Requires:       python2-rhn-client-tools
Requires:       python2-uyuni-common-libs
BuildRequires:  python
%if 0%{?suse_version}
# aaa_base provide chkconfig
Requires:       aaa_base
# provide directories for filelist check in obs
BuildRequires:  rhn-check
BuildRequires:  rhn-client-tools
%else
Requires:       chkconfig
%endif
%description -n python2-%{name}-common
This package contains files that are needed by the rhn-virtualization-host
package.
%endif

%if 0%{?build_py3}
%package -n python3-%{name}-common
Summary:        Files needed by rhn-virtualization-host
Group:          System Environment/Base
Provides:       python3-%{oldname}-common = %{oldversion}
Obsoletes:      python3-%{oldname}-common < %{oldversion}
Obsoletes:      %{name}-common < %{oldversion}
Obsoletes:      %{oldname}-common < %{oldversion}
Requires:       python3-rhn-client-tools
Requires:       python3-uyuni-common-libs
BuildRequires:  python3-devel

%description -n python3-%{name}-common
This package contains files that are needed by the rhn-virtualization-host
package.
%endif

%package host
Summary:        Spacewalk Virtualization support specific to the Host system
Group:          System Environment/Base
Provides:       %{oldname}-host = %{oldversion}
Obsoletes:      %{oldname}-host < %{oldversion}
Requires:       %{pythonX}-%{name}-host = %{version}-%{release}

%if 0%{?default_py3}
BuildRequires:  systemd
Requires(pre): systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%else
%if 0%{?suse_version}
Requires:       cron
%else
Requires:       /usr/sbin/crond
%endif
%endif

%description host
This package contains code for Spacewalk's Virtualization support
that is specific to the Host system (a.k.a. Dom0).

%if 0%{?build_py2}
%package -n python2-%{name}-host
Summary:        RHN/Spacewalk Virtualization support specific to the Host system
Group:          System Environment/Base
Provides:       python2-%{oldname}-host = %{oldversion}
Obsoletes:      python2-%{oldname}-host < %{oldversion}
Requires:       %{name}-host = %{version}-%{release}
Requires:       libvirt-python
Requires:       python2-%{name}-common = %{version}-%{release}
%if 0%{?suse_version}
Requires:       python-curl
%else
Requires:       python-pycurl
%endif
%description -n python2-%{name}-host
Python 2 files for %{name}-host.
%endif

%if 0%{?build_py3}
%package -n python3-%{name}-host
Summary:        RHN/Spacewalk Virtualization support specific to the Host system
Group:          System Environment/Base
Provides:       python3-%{oldname}-host = %{oldversion}
Obsoletes:      python3-%{oldname}-host < %{oldversion}
Requires:       %{name}-host = %{version}-%{release}
%if 0%{?suse_version}
Requires:       python3-libvirt-python
%else
Requires:       libvirt-python3
%endif
Requires:       python3-%{name}-common = %{version}-%{release}
Requires:       python3-pycurl

%description -n python3-%{name}-host
Python 3 files for %{name}-host.
%endif

%prep
%setup -q -n mgr-virtualization-git-0.0daba5b

%build
make -f Makefile.rhn-virtualization

%install
%if 0%{?build_py2}
make -f Makefile.rhn-virtualization DESTDIR=$RPM_BUILD_ROOT PKGDIR0=%{_initrddir} \
        PYTHONPATH=%{python_sitelib} install
sed -i 's,@PYTHON@,python,; s,@PYTHONPATH@,%{python_sitelib},;' \
        $RPM_BUILD_ROOT/%{_initrddir}/rhn-virtualization-host
%endif

%if 0%{?build_py3}
make -f Makefile.rhn-virtualization DESTDIR=$RPM_BUILD_ROOT PKGDIR0=%{_initrddir} \
        PYTHONPATH=%{python3_sitelib} install
        sed -i 's,@PYTHON@,python3,; s,@PYTHONPATH@,%{python3_sitelib},;' \
                $RPM_BUILD_ROOT/%{_initrddir}/rhn-virtualization-host
%endif

%if 0%{?default_py3}
install -d %{buildroot}%{_unitdir}
install -D -m 0644 scripts/mgr-virtualization.timer %{buildroot}%{_unitdir}/mgr-virtualization.timer
install -D -m 0644 scripts/mgr-virtualization.service %{buildroot}%{_unitdir}/mgr-virtualization.service
sed -i 's,@PYTHON@,/usr/bin/python3,; s,@PYTHONPATH@,%{python3_sitelib},;' \
       %{buildroot}%{_unitdir}/mgr-virtualization.service

%else
install -d $RPM_BUILD_ROOT%{cron_dir}
install -D -m 0644 scripts/rhn-virtualization.cron $RPM_BUILD_ROOT%{cron_dir}/rhn-virtualization.cron
sed -i 's,@PYTHON@,/usr/bin/python,; s,@PYTHONPATH@,%{python_sitelib},;' \
        $RPM_BUILD_ROOT/%{cron_dir}/rhn-virtualization.cron
%endif

%if 0%{?suse_version}
rm -f $RPM_BUILD_ROOT/%{_initrddir}/rhn-virtualization-host
%endif

%if 0%{?suse_version}
%py_compile -O %{buildroot}/%{python_sitelib}
%if 0%{?build_py3}
%py3_compile -O %{buildroot}/%{python3_sitelib}
%endif
%endif

%if 0%{?suse_version}
rm -f $RPM_BUILD_ROOT/%{_initrddir}/rhn-virtualization-host
%py_compile -O %{buildroot}/%{python_sitelib}
%if 0%{?build_py3}
%py3_compile -O %{buildroot}/%{python3_sitelib}
%endif
%endif

%if 0%{?suse_version}
%post host
if [ -d /proc/xen ]; then
    # xen kernel is running
    # change the default template to the xen version
    sed -i 's@^IMAGE_CFG_TEMPLATE=/etc/sysconfig/rhn/kvm-template.xml@IMAGE_CFG_TEMPLATE=/etc/sysconfig/rhn/xen-template.xml@' /etc/sysconfig/rhn/image.cfg
fi
%if 0%{?default_py3}
%service_add_post mgr-virtualization.timer

%pre
%service_add_pre mgr-virtualization.timer

%preun
%service_del_preun mgr-virtualization.timer

%postun
%service_del_postun mgr-virtualization.timer
%endif

%else

%if 0%{?default_py3}
%{!?systemd_post: %global systemd_post() if [ $1 -eq 1 ] ; then /usr/bin/systemctl enable %%{?*} >/dev/null 2>&1 || : ; fi; }
%{!?systemd_preun: %global systemd_preun() if [ $1 -eq 0 ] ; then /usr/bin/systemctl --no-reload disable %%{?*} > /dev/null 2>&1 || : ; /usr/bin/systemctl stop %%{?*} > /dev/null 2>&1 || : ; fi; }
%{!?systemd_postun_with_restart: %global systemd_postun_with_restart() /usr/bin/systemctl daemon-reload >/dev/null 2>&1 || : ; if [ $1 -ge 1 ] ; then /usr/bin/systemctl try-restart %%{?*} >/dev/null 2>&1 || : ; fi; }
%endif

%post host
%if 0%{?default_py3}
%systemd_post mgr-virtualization.timer
%else
/sbin/chkconfig --add rhn-virtualization-host
/sbin/service crond condrestart
%endif
if [ -d /proc/xen ]; then
    # xen kernel is running
    # change the default template to the xen version
    sed -i 's@^IMAGE_CFG_TEMPLATE=/etc/sysconfig/rhn/kvm-template.xml@IMAGE_CFG_TEMPLATE=/etc/sysconfig/rhn/xen-template.xml@' /etc/sysconfig/rhn/image.cfg
fi

%preun host
%if 0%{?default_py3}
%systemd_preun mgr-virtualization.timer
%else
if [ $1 = 0 ]; then
  /sbin/chkconfig --del rhn-virtualization-host
fi
%endif

%postun host
%if 0%{?default_py3}
%systemd_postun_with_restart mgr-virtualization.timer
%else
/sbin/service crond condrestart
%endif
%endif

%if 0%{?build_py2}
%files -n python2-%{name}-common
%defattr(-,root,root,-)
%dir %{python_sitelib}/virtualization
%{python_sitelib}/virtualization/__init__.py*
%{python_sitelib}/virtualization/batching_log_notifier.py*
%{python_sitelib}/virtualization/constants.py*
%{python_sitelib}/virtualization/errors.py*
%{python_sitelib}/virtualization/notification.py*
%{python_sitelib}/virtualization/util.py*
%doc LICENSE
%if 0%{?suse_version}
%dir %{python_sitelib}/virtualization
%endif
%endif

%if 0%{?build_py3}
%files -n python3-%{name}-common
%defattr(-,root,root,-)
%dir %{python3_sitelib}/virtualization
%{python3_sitelib}/virtualization/__init__.py*
%{python3_sitelib}/virtualization/batching_log_notifier.py*
%{python3_sitelib}/virtualization/constants.py*
%{python3_sitelib}/virtualization/errors.py*
%{python3_sitelib}/virtualization/notification.py*
%{python3_sitelib}/virtualization/util.py*
%doc LICENSE
%dir %{python3_sitelib}/virtualization/__pycache__
%{python3_sitelib}/virtualization/__pycache__/__init__.*
%{python3_sitelib}/virtualization/__pycache__/batching_log_notifier.*
%{python3_sitelib}/virtualization/__pycache__/constants.*
%{python3_sitelib}/virtualization/__pycache__/errors.*
%{python3_sitelib}/virtualization/__pycache__/notification.*
%{python3_sitelib}/virtualization/__pycache__/util.*
%if 0%{?suse_version}
%dir %{python3_sitelib}/virtualization
%endif
%endif

%files host
%defattr(-,root,root,-)
%if 0%{?suse_version}
%dir %{rhn_conf_dir}
%else
%{_initrddir}/rhn-virtualization-host
%endif
%dir %{rhn_conf_dir}/virt
%dir %{rhn_conf_dir}/virt/auto
%if 0%{?default_py3}
%{_unitdir}/mgr-virtualization.service
%{_unitdir}/mgr-virtualization.timer
%else
%config(noreplace) %attr(644,root,root) %{cron_dir}/rhn-virtualization.cron
%endif
%{rhn_conf_dir}/*-template.xml
%config(noreplace) %{rhn_conf_dir}/image.cfg
%doc LICENSE

%if 0%{?build_py2}
%files -n python2-%{name}-host
%defattr(-,root,root,-)
%dir %{python_sitelib}/rhn
%dir %{python_sitelib}/rhn/actions
%{python_sitelib}/virtualization/domain_config.py*
%{python_sitelib}/virtualization/domain_control.py*
%{python_sitelib}/virtualization/domain_directory.py*
%{python_sitelib}/virtualization/get_config_value.py*
%{python_sitelib}/virtualization/init_action.py*
%{python_sitelib}/virtualization/poller.py*
%{python_sitelib}/virtualization/schedule_poller.py*
%{python_sitelib}/virtualization/poller_state_cache.py*
%{python_sitelib}/virtualization/start_domain.py*
%{python_sitelib}/virtualization/state.py*
%{python_sitelib}/virtualization/support.py*
%{python_sitelib}/rhn/actions/virt.py*
%{python_sitelib}/rhn/actions/image.py*
%if 0%{?suse_version}
%dir %{python_sitelib}/rhn
%dir %{python_sitelib}/rhn/actions
%endif
%endif

%if 0%{?build_py3}
%files -n python3-%{name}-host
%defattr(-,root,root,-)
%dir %{python3_sitelib}/rhn
%dir %{python3_sitelib}/rhn/actions
%dir %{python3_sitelib}/rhn/actions/__pycache__
%{python3_sitelib}/virtualization/domain_config.py*
%{python3_sitelib}/virtualization/domain_control.py*
%{python3_sitelib}/virtualization/domain_directory.py*
%{python3_sitelib}/virtualization/get_config_value.py*
%{python3_sitelib}/virtualization/init_action.py*
%{python3_sitelib}/virtualization/poller.py*
%{python3_sitelib}/virtualization/schedule_poller.py*
%{python3_sitelib}/virtualization/poller_state_cache.py*
%{python3_sitelib}/virtualization/start_domain.py*
%{python3_sitelib}/virtualization/state.py*
%{python3_sitelib}/virtualization/support.py*
%{python3_sitelib}/rhn/actions/virt.py*
%{python3_sitelib}/rhn/actions/image.py*
%{python3_sitelib}/virtualization/__pycache__/domain_config.*
%{python3_sitelib}/virtualization/__pycache__/domain_control.*
%{python3_sitelib}/virtualization/__pycache__/domain_directory.*
%{python3_sitelib}/virtualization/__pycache__/get_config_value.*
%{python3_sitelib}/virtualization/__pycache__/init_action.*
%{python3_sitelib}/virtualization/__pycache__/poller.*
%{python3_sitelib}/virtualization/__pycache__/schedule_poller.*
%{python3_sitelib}/virtualization/__pycache__/poller_state_cache.*
%{python3_sitelib}/virtualization/__pycache__/start_domain.*
%{python3_sitelib}/virtualization/__pycache__/state.*
%{python3_sitelib}/virtualization/__pycache__/support.*
%{python3_sitelib}/rhn/actions/__pycache__/virt.*
%{python3_sitelib}/rhn/actions/__pycache__/image.*
%if 0%{?suse_version}
%dir %{python3_sitelib}/rhn
%dir %{python3_sitelib}/rhn/actions
%dir %{python3_sitelib}/rhn/actions/__pycache__
%endif
%endif

%changelog
* Fri Sep 18 2020 jgonzalez@suse.com
- version 4.2.1-1
- Update package version to 4.2.0
* Wed Nov 27 2019 jgonzalez@suse.com
- version 4.1.1-1
- replace spacewalk-usix with uyuni-common-libs
- Bump version to 4.1.0 (bsc#1154940)
- Require mgr-daemon (new name of spacewalksd) so we systems with
  spacewalksd get always the new package installed (bsc#1149353)
- Fix mgr-virtualization timer
* Thu Aug  1 2019 jgonzalez@suse.com
- version 4.0.8-1
- fix package dependencies to prevent file conflict (bsc#1143856)
* Wed Jul 31 2019 jgonzalez@suse.com
- version 4.0.7-1
- Fix missing python 3 ugettext (bsc#1138494)
* Wed May 15 2019 jgonzalez@suse.com
- version 4.0.6-1
- Obsolete newer versions of rhn-virtualization
* Wed May 15 2019 jgonzalez@suse.com
- version 4.0.5-1
- SPEC cleanup
- Fix wrong bugzilla entry at changelog
* Mon Apr 22 2019 jgonzalez@suse.com
- version 4.0.4-1
- add makefile and pylint configuration
* Mon Mar 25 2019 jgonzalez@suse.com
- version 4.0.3-1
- convert poller to systemd timer (bsc#1115414)
* Fri Oct 26 2018 jgonzalez@suse.com
- version 4.0.2-1
- Fix Obsolete/Provides for subpackage python2-mgr-virtualization-host
  (bsc#1104034)
* Fri Aug 10 2018 jgonzalez@suse.com
- version 4.0.1-1
- Bump version to 4.0.0 (bsc#1104034)
- Rename package to mgr-virtualization to allow version 4.0.0 (bsc#1104034)
- Fix copyright for the package specfile (bsc#1103696)
* Wed Apr 25 2018 jgonzalez@suse.com
- version 5.4.72.2-1
- Remove SUSE Studio based image deployments (bsc#1090504)
* Mon Mar 26 2018 jgonzalez@suse.com
- version 5.4.72.1-1
- Sync with upstream (bsc#1083294)
- Build python2 packages on SUSE systems
* Mon Mar  5 2018 jgonzalez@suse.com
- version 5.4.71.2-1
- remove empty clean section from spec (bsc#1083294)
* Fri Feb 23 2018 jgonzalez@suse.com
- version 5.4.71.1-1
- Sync with upstream
* Fri Nov 10 2017 mc@suse.de
- version 5.4.69.1-1
- simplify status check
- open cache file in binary mode
- fixing traceback from poller.py on Python 3
- fixing a bytes-like object is required, not 'str'
* Thu Oct 26 2017 mc@suse.de
- version 5.4.64.1-1
- move files into proper python2/python3 subpackages
* Tue Mar  7 2017 mc@suse.de
- version 5.4.57.1-1
- Updated links to github in spec files
- require spacewalk-usix indead of spacewalk-backend-usix
* Wed Jan 11 2017 michele.bologna@suse.com
- version 5.4.56.1-1
- Version 5.4.56-1
* Thu Oct 22 2015 mc@suse.de
- version 5.4.55.2-1
- fix guest report of virtual hosts (bsc#950372)
* Wed Oct  7 2015 mc@suse.de
- version 5.4.55.1-1
- Bump version
* Tue Feb  3 2015 mc@suse.de
- version 5.4.50.5-1
- Getting rid of Tabs and trailing spaces
* Thu Dec 18 2014 mc@suse.de
- version 5.4.50.4-1
* Wed Sep  3 2014 ro@suse.de
- sanitize release line in specfile
* Tue May  6 2014 mc@suse.de
- version 5.4.50.3-1
- some systems to not have /sbin in path
- service location is not platform independent
- rhn-virt-host should not spam root if libvirtd is stopped
* Thu Apr 10 2014 mc@suse.de
- version 5.4.50.2-1
* Thu Apr 10 2014 mc@suse.de
- fix release in specfile for SLE12 (bnc#872970)
* Mon Dec  9 2013 mc@suse.de
- version 5.4.50.1-1
- switch to 2.1
* Wed Jun 12 2013 mc@suse.de
- version 5.4.34.13-1
- python 2.4 fix for 'exit'
- define a utf8_encode wrapper
* Thu Apr  4 2013 mc@suse.de
- version 5.4.34.12-1
- isInstallerConfig should check for autoyast in commandline
- catch libvirtError to return meaningfull error messages
- remove wrong kernel and initrd pathes from config
- Fix deployment of vmdk studio images (bnc#806202)
* Fri Feb  8 2013 mc@suse.de
- version 5.4.34.11-1
- rhn-virtualization-host needs to consistantly use the new function
  definition
- support studio KVM image type (bnc#797057)
* Thu Nov 22 2012 jrenner@suse.de
- version 5.4.34.10-1
- fix invalid return value in image deployment (bnc#786159)
* Mon Jul 16 2012 ug@suse.de
- version 5.4.34.9-1
- rhn-profile-sync exits with status 1 if libvirtd is not running
* Mon Jun 25 2012 mc@suse.de
- version 5.4.34.8-1
- fix typo in type checking
* Mon Jun 25 2012 mc@suse.de
- version 5.4.34.7-1
- better support VirtualBox using listDefinedDomains in poller
  tool
* Thu Jun 21 2012 jrenner@suse.de
- version 5.4.34.6-1
- Support for studio image deployments, upstream integration
* Thu May 31 2012 mc@suse.de
- version 5.4.34.5-1
- requires python-pycurl on redhat/fedora now
- remove debugging code
* Mon May 14 2012 mc@suse.de
- version 5.4.34.4-1
- fixed proxySettings for image fetching
* Wed May  9 2012 ug@suse.de
- packaging of config file fixed
* Wed May  9 2012 mc@suse.de
- version 5.4.34.3-1
- no use of /var/lock/subsys/ anymore
* Tue May  8 2012 ug@suse.de
- added generate_uuid to utils.py
- inegrated upstream feedback to studio integration (bnc#764532)
* Fri Apr 27 2012 mc@suse.de
- version 5.4.34.2-1
- rhn-virtualization-host should not delete chkconfig settings on
  upgrade
* Wed Mar 21 2012 mc@suse.de
- version 5.4.34.1-1
- Bumping package version
* Thu Mar 15 2012 jrenner@suse.de
- Add support for studio image deployments
* Thu Nov  3 2011 ma@suse.de
- Adapt dependencies to renamed packages (bnc#722052)
* Fri Oct 28 2011 ug@suse.de
- Status of Virtual Machines is not properly recognized
  (bnc#683075)
* Fri Oct 21 2011 ug@suse.de
- catch an exception when libvirtd is not running (bnc#696294)
* Mon Feb  7 2011 mc@suse.de
- add missing dir
* Mon Feb  7 2011 mc@suse.de
- add rc link (bnc#669894)
* Tue Jan 11 2011 mc@suse.de
- change strings in init script
* Tue Nov  2 2010 mantel@suse.de
- don't ignore post-build-checks
* Wed Sep 22 2010 mantel@suse.de
- move SuSE specific init script to scripts to make tito happy
* Wed Sep 15 2010 mantel@suse.de
- fix post-build-checks
* Tue Sep 14 2010 mantel@suse.de
- Initial release of rhn-virtualization
